-- MordenFunction
-- Author: Home
-- DateCreated: 6/6/2015 1:33:42 PM
--------------------------------------------------------------
-- ڵ ̰ ͼ 
--------------------------------------------------------------
-- Pre Setting
--------------------------------------------------------------
function Cons_IsCivilisationActive(pWerebeastCiv)
	for iSlot = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
		local slotStatus = PreGame.GetSlotStatus(iSlot)
		if (slotStatus == SlotStatus["SS_TAKEN"] or slotStatus == SlotStatus["SS_COMPUTER"]) then
			if PreGame.GetCivilization(iSlot) == pMordenCiv then
				return true
			end
		end
	end
	return false
end

--------------------------------------------------------------
-- Trait
--------------------------------------------------------------
local pMordenCiv				= GameInfoTypes["CIVILIZATION_MORDEN"]
local pMordenPolicyTrait		= GameInfoTypes["POLICY_DUMMY_MORDEN_ARMY_BUILDING"]
local pMordenBuildingTrait		= GameInfoTypes["BUILDING_MORDEN_TRAIT_DUMMY_BUILDING"]
local pEraModern				= GameInfoTypes["ERA_MODERN"]
local isMordenCivActive			= Cons_IsCivilisationActive(pWerebeastCiv)

if isMordenCivActive then
	print("Morden is raise the rebellion")
end

function MordenTraitBuildingFunction()
	 for iPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
		local pPlayer = Players[iPlayer];
		if (pPlayer:GetCivilizationType() == pMordenCiv) then
			if not pPlayer:HasPolicy(pMordenPolicyTrait) then
				pPlayer:SetNumFreePolicies(1)
				pPlayer:SetNumFreePolicies(0)
				pPlayer:SetHasPolicy(pMordenPolicyTrait, true)
			end
		end
    end
end	

if isMordenCivActive then
	Events.SequenceGameInitComplete.Add(MordenTraitBuildingFunction)
end

function MordenTraitUnitFunction()
	 for iPlayer = 0, GameDefines.MAX_MAJOR_CIVS-1, 1 do
		local pPlayer = Players[iPlayer];
		if (pPlayer:GetCivilizationType() == pMordenCiv) then
			local iEra = pPlayer:GetCurrentEra()
			if (iEra >= pEraModern) then
				for pCity in pPlayer:Cities() do
					pCity:SetNumRealBuilding(pMordenBuildingTrait, 1)
				end
			end
		end
    end
end	

if isMordenCivActive then
	GameEvents.PlayerDoTurn.Add(MordenTraitUnitFunction)
end

function BanMGW(iPlayer, iUnitMGW)
	local pPlayer		= Players[iPlayer]
	local pBuildingMGW	= GameInfoTypes["BUILDING_DECISIONS_MORDEN_SUPER_GIANT_WEAPON"]
	local pMordenGL		= GameInfoTypes["UNIT_MORDEN_GIANT_LAND_WEAPON"]
	local pMordenGS		= GameInfoTypes["UNIT_MORDEN_GIANT_SEA_WEAPON"]

	if (iPlayer == 63) then 
		if ((iUnitMGW == pMordenGL) or (iUnitMGW == pMordenGS)) then
			return false
		end
	end
	if (pPlayer:GetCivilizationType() ~= pMordenCiv) then
		if ((iUnitMGW == pMordenGL) or (iUnitMGW == pMordenGS)) then
			return false
		end
	end
	if (pPlayer:GetCivilizationType() == pMordenCiv) then
		for pCity in pPlayer:Cities() do
			if (not pCity:IsHasBuilding(iBuildingMGW))  then
				if ((iUnitMGW == pMordenGL) or (iUnitMGW == pMordenGS)) then
					return false
				end
			else
				if ((iUnitMGW == pMordenGL) and (iUnitMGW == pMordenGS)) then
					return true
				end
			end
		end
	end
	return true
end

GameEvents.PlayerCanTrain.Add(BanMGW)