--=======================================================================================================================
-- Bingle's Civ IV Traits
--=======================================================================================================================
-- Leader_SharedTraits
------------------------------	
--CREATE TABLE IF NOT EXISTS 
--    Leader_SharedTraits (
--    LeaderType          text    REFERENCES Leaders(Type)        default null,
--    TraitOne            text    REFERENCES Policies(Type)       default null,
--    TraitTwo            text    REFERENCES Policies(Type)       default null);
--     
--INSERT OR REPLACE INTO Leader_SharedTraits
--            (LeaderType,				TraitOne,				TraitTwo)
--VALUES      ('LEADER_DONALD_MORDEN',	'POLICY_AGGRESSIVE_X',	'POLICY_CHARISMATIC_X');
------------------------------	
-- Leaders
------------------------------	
--UPDATE Language_en_US 
--SET Text = (CASE WHEN EXISTS(SELECT Type FROM Policies WHERE Type = 'POLICY_AGGRESSIVE_X' )
--	THEN 'Donald Morden [ICON_WAR][ICON_HAPPINESS_1]'
--	ELSE 'Donald Morden' END) 
--WHERE Tag = 'TXT_KEY_LEADER_DONALD_MORDEN';

--UPDATE Language_ko_KR 
--SET Text = (CASE WHEN EXISTS(SELECT Type FROM Policies WHERE Type = 'POLICY_AGGRESSIVE_X' )
--	THEN 'ε  [ICON_WAR][ICON_HAPPINESS_1]'
--	ELSE 'ε ' END) 
--WHERE Tag = 'TXT_KEY_LEADER_DONALD_MORDEN';

--==========================================================================================================================
-- BrutalSamurai's Ethnic Units/Gedemon's R.E.D.
--==========================================================================================================================
-- Civilizations
------------------------------	
UPDATE Civilizations 
SET ArtStyleSuffix = (CASE WHEN EXISTS(SELECT ArtStyleSuffix FROM Civilizations WHERE ArtStyleSuffix = '_GERMANY' )
	THEN '_GERMANY'
	ELSE '_EURO' END) 
WHERE Type = 'CIVILIZATION_MORDEN';

--==========================================================================================================================
-- JFD's Cultural Diversity
--==========================================================================================================================
-- Civilization_JFD_CultureTypes
------------------------------	
CREATE TABLE IF NOT EXISTS 
Civilization_JFD_CultureTypes (
	CivilizationType 							text 	REFERENCES Civilizations(Type) 		default null,
	CultureType 								text										default null,
	SplashScreenTag								text										default	null,
	SoundtrackTag								text										default	null);

INSERT OR REPLACE INTO Civilization_JFD_CultureTypes
			(CivilizationType,					CultureType,		SplashScreenTag,	SoundtrackTag)
VALUES		('CIVILIZATION_MORDEN',				'JFD_Western',		'JFD_Western',		'JFD_Western');
------------------------------	
-- Civilizations
------------------------------	
UPDATE Civilizations 
SET SoundtrackTag = (CASE WHEN EXISTS(SELECT SoundtrackTag FROM Civilizations WHERE SoundtrackTag = 'JFD_Totalitarian' )
	THEN 'JFD_Totalitarian'
	ELSE 'Germany' END) 
WHERE Type = 'CIVILIZATION_MORDEN';

--==========================================================================================================================	
-- JFD's Piety & Prestige
--==========================================================================================================================			
-- Flavors
------------------------------	
INSERT OR REPLACE INTO Flavors 
			(Type)
VALUES		('FLAVOR_JFD_RELIGIOUS_INTOLERANCE');
------------------------------
-- Leader_Flavors
------------------------------
INSERT INTO Leader_Flavors
			(LeaderType,				FlavorType,							Flavor)
VALUES		('LEADER_DONALD_MORDEN',		'FLAVOR_JFD_RELIGIOUS_INTOLERANCE',	0);

--=======================================================================================================================
-- Civilizations_YagemStartPosition
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_YagemStartPosition(Type, X, Y, AltX, AltY);
INSERT INTO Civilizations_YagemStartPosition
			(Type,									X,		Y,		AltX,	AltY)
SELECT		('CIVILIZATION_MORDEN'),	X,		Y,		AltX,	AltY
FROM Civilizations_YagemStartPosition WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_YahemStartPosition
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_YahemStartPosition(Type, X, Y, AltX, AltY);
INSERT INTO Civilizations_YahemStartPosition
			(Type,									X,		Y,		AltX,	AltY)
SELECT		('CIVILIZATION_MORDEN'),	X,		Y,		AltX,	AltY
FROM Civilizations_YahemStartPosition WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_CordiformStartPosition
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_CordiformStartPosition(Type, X, Y, AltX, AltY);
INSERT INTO Civilizations_CordiformStartPosition
			(Type,									X,		Y,		AltX,	AltY)
SELECT		('CIVILIZATION_MORDEN'),	X,		Y,		AltX,	AltY
FROM Civilizations_CordiformStartPosition WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_GreatestEarthStartPosition
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_GreatestEarthStartPosition(Type, X, Y, AltX, AltY);
INSERT INTO Civilizations_GreatestEarthStartPosition
			(Type,									X,		Y,		AltX,	AltY)
SELECT		('CIVILIZATION_MORDEN'),	X,		Y,		AltX,	AltY
FROM Civilizations_GreatestEarthStartPosition WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_EuroGiantStartPosition
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_EuroGiantStartPosition(Type, X, Y, AltX, AltY);
INSERT INTO Civilizations_EuroGiantStartPosition
			(Type,									X,		Y,		AltX,	AltY)
SELECT		('CIVILIZATION_MORDEN'),	X,		Y,		AltX,	AltY
FROM Civilizations_EuroGiantStartPosition WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_EuroLargeStartPosition
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_EuroLargeStartPosition(Type, X, Y, AltX, AltY);
INSERT INTO Civilizations_EuroLargeStartPosition
			(Type,									X,		Y,		AltX,	AltY)
SELECT		('CIVILIZATION_MORDEN'),	X,		Y,		AltX,	AltY
FROM Civilizations_EuroLargeStartPosition WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_NorthAtlanticStartPosition
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_NorthAtlanticStartPosition(Type, X, Y, AltX, AltY);
INSERT INTO Civilizations_NorthAtlanticStartPosition
			(Type,									X,		Y,		AltX,	AltY)
SELECT		('CIVILIZATION_MORDEN'),	X,		Y,		AltX,	AltY
FROM Civilizations_NorthAtlanticStartPosition WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_NorthWestEuropeStartPosition
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_NorthWestEuropeStartPosition(Type, X, Y, AltX, AltY);
INSERT INTO Civilizations_NorthWestEuropeStartPosition
			(Type,									X,		Y,		AltX,	AltY)
SELECT		('CIVILIZATION_MORDEN'),	X,		Y,		AltX,	AltY
FROM Civilizations_NorthWestEuropeStartPosition WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_CaribbeanStartPosition
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_CaribbeanStartPosition(Type, X, Y, AltX, AltY);
INSERT INTO Civilizations_CaribbeanStartPosition
			(Type,									X,		Y,		AltX,	AltY)
SELECT		('CIVILIZATION_MORDEN'),	X,		Y,		AltX,	AltY
FROM Civilizations_CaribbeanStartPosition WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_MediterraneanStartPosition
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_MediterraneanStartPosition(Type, X, Y, AltX, AltY);
INSERT INTO Civilizations_MediterraneanStartPosition
			(Type,									X,		Y,		AltX,	AltY)
SELECT		('CIVILIZATION_MORDEN'),	X,		Y,		AltX,	AltY
FROM Civilizations_MediterraneanStartPosition WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_AmericasStartPosition
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_AmericasStartPosition(Type, X, Y, AltX, AltY);
INSERT INTO Civilizations_AmericasStartPosition
			(Type,									X,		Y,		AltX,	AltY)
SELECT		('CIVILIZATION_MORDEN'),	X,		Y,		AltX,	AltY
FROM Civilizations_AmericasStartPosition WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_YagemRequestedResource
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_YagemRequestedResource(Type, Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4);
INSERT INTO Civilizations_YagemRequestedResource
			(Type, 									Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4)
SELECT		('CIVILIZATION_MORDEN'),	Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4
FROM Civilizations_YagemRequestedResource WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_YahemRequestedResource
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_YahemRequestedResource(Type, Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4);
INSERT INTO Civilizations_YahemRequestedResource
			(Type, 									Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4)
SELECT		('CIVILIZATION_MORDEN'),	Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4
FROM Civilizations_YahemRequestedResource WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_GreatestEarthRequestedResource
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_GreatestEarthRequestedResource(Type, Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4);
INSERT INTO Civilizations_GreatestEarthRequestedResource
			(Type, 									Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4)
SELECT		('CIVILIZATION_MORDEN'),	Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4
FROM Civilizations_GreatestEarthRequestedResource WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_EuroGiantRequestedResource
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_EuroGiantRequestedResource(Type, Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4);
INSERT INTO Civilizations_EuroGiantRequestedResource
			(Type, 									Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4)
SELECT		('CIVILIZATION_MORDEN'),	Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4
FROM Civilizations_EuroGiantRequestedResource WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_EuroLargeRequestedResource
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_EuroLargeRequestedResource(Type, Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4);
INSERT INTO Civilizations_EuroLargeRequestedResource
			(Type, 									Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4)
SELECT		('CIVILIZATION_MORDEN'),	Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4
FROM Civilizations_EuroLargeRequestedResource WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_AmericasRequestedResource
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_AmericasRequestedResource(Type, Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4);
INSERT INTO Civilizations_AmericasRequestedResource
			(Type, 									Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4)
SELECT		('CIVILIZATION_MORDEN'),	Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4
FROM Civilizations_AmericasRequestedResource WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_CaribbeanRequestedResource
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_CaribbeanRequestedResource(Type, Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4);
INSERT INTO Civilizations_CaribbeanRequestedResource
			(Type, 									Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4)
SELECT		('CIVILIZATION_MORDEN'),	Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4
FROM Civilizations_CaribbeanRequestedResource WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
-- Civilizations_NorthAtlanticRequestedResource
--=======================================================================================================================
CREATE TABLE IF NOT EXISTS Civilizations_NorthAtlanticRequestedResource(Type, Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4);
INSERT INTO Civilizations_NorthAtlanticRequestedResource
			(Type, 									Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4)
SELECT		('CIVILIZATION_MORDEN'),	Req1, Yield1, Req2, Yield2, Req3, Yield3, Req4, Yield4
FROM Civilizations_NorthAtlanticRequestedResource WHERE Type = 'CIVILIZATION_GERMANY';
--=======================================================================================================================
--=======================================================================================================================